// ====================================================================
// Allan CORNET
// DIGITEO 2010
// ====================================================================
ilib_verbose(0);
// ====================================================================
// <-- CLI SHELL MODE -->
// ====================================================================
ilib_verbose(0);
TMP_OS_DIR=TMPDIR;
TMP_DIR = TMP_OS_DIR+filesep()+'ilib_build';
rmdir(TMP_DIR,'s');
mkdir(TMP_OS_DIR,'ilib_build');
if ~isdir(TMP_DIR) then pause,end;

//Here with give a complete example on adding new primitive to Scilab
//create the procedure files
f1=['extern double fun2();'
    'void fun1(double *x, double *y)'
    '{*y=fun2(*x)/(*x);}'];

mputl(f1,TMP_DIR+filesep()+'fun1.c');

f2=['#include <math.h>'
    'double fun2(double x)'
    '{ return( sin(x+1.));}'];
    
mputl(f2,TMP_DIR+filesep()+'fun2.c');
//creating the interface file
i=['#include ""api_scilab.h""'
   'extern int fun1 ( double *x, double *y);'
   'int intfun1(char* fname, void* pvApiCtx)' 
   '{'
   '  int* piAddr = NULL;'
   '  double data = 0;'
   '  double res = 0;'
   '  getVarAddressFromPosition(pvApiCtx, 1, &piAddr);'
   '  getScalarDouble(pvApiCtx, piAddr, &data);'
   '  fun1(&data, &res);'
   '  createScalarDouble(pvApiCtx, nbInputArgument(pvApiCtx) + 1, res);'
   '  AssignOutputVariable(pvApiCtx, 1) = nbInputArgument(pvApiCtx) + 1;'
   '  return 0;'
   '}'];
mputl(i,TMP_DIR+filesep()+'intfun1.c');


//creating the shared library (a gateway, a Makefile and a loader are 
//generated. 
cur_dir = pwd();
chdir(TMP_DIR);

files=['fun1.c','fun2.c','intfun1.c'];
ilib_build('foo',['scifun1','intfun1'],files,[]);

// load the shared library 
exec loader.sce;

chdir(cur_dir);

//using the new primitive
if ( norm(scifun1(33) - .0160328) > 1 ) then pause,end

// ulink() all libraries
ulink();

//remove TMP_DIR
rmdir(TMP_DIR,'s');
// ====================================================================
