// ====================================================================
// Allan CORNET
// DIGITEO 2010
// ====================================================================
ilib_verbose(0);
// ====================================================================
// <-- CLI SHELL MODE -->
// ====================================================================
TMP_OS_DIR = getenv('TMP','err');
if (TMP_OS_DIR == 'err') then pause,end;
TMP_DIR = TMP_OS_DIR+filesep()+'ilib_build_2';

rmdir(TMP_DIR,'s');
mkdir(TMP_OS_DIR,'ilib_build_2');


if ~isdir(TMP_DIR) then pause,end;


//Here with give a complete example on adding new primitive to Scilab
//create the procedure files

f1=['void c_sum(double *a,double *b, double *sum)'
    '{*sum=*a + *b;}'];

mputl(f1,TMP_DIR+filesep()+'c_sum.c');

f2=['void c_sub(double *a,double *b, double *sub)'
    '{*sub=*a - *b;}'];
mputl(f2,TMP_DIR+filesep()+'c_sub.c');

//creating the interface file
i=['#include ""api_scilab.h""'
   'extern void c_sum(double *a,double *b, double *sum);'
   'int sci_csum(char *fname, void* pvApiCtx)' 
   '{'
   '  int *piAddr1 = NULL, *piAddr2 = NULL;'
   '  double data1 = 0, data2 = 0;'
   '  double res = 0;'
   '  getVarAddressFromPosition(pvApiCtx, 1, &piAddr1);'
   '  getVarAddressFromPosition(pvApiCtx, 2, &piAddr2);'
   '  getScalarDouble(pvApiCtx, piAddr1, &data1);'
   '  getScalarDouble(pvApiCtx, piAddr2, &data2);'
   '  c_sum(&data1, &data2, &res);'
   '  createScalarDouble(pvApiCtx, nbInputArgument(pvApiCtx) + 1, res);'
   '  AssignOutputVariable(pvApiCtx, 1) = nbInputArgument(pvApiCtx) + 1;'
   '  return 0;'
   '}'];
mputl(i,TMP_DIR+filesep()+'sci_csum.c');

//creating the interface file
j=['#include ""api_scilab.h""'
   'extern void c_sub(double *a,double *b, double *sum);'
   'int sci_csub(char *fname, void* pvApiCtx)' 
   '{'
   '  int *piAddr1 = NULL, *piAddr2 = NULL;'
   '  double data1 = 0, data2 = 0;'
   '  double res = 0;'
   '  getVarAddressFromPosition(pvApiCtx, 1, &piAddr1);'
   '  getVarAddressFromPosition(pvApiCtx, 2, &piAddr2);'
   '  getScalarDouble(pvApiCtx, piAddr1, &data1);'
   '  getScalarDouble(pvApiCtx, piAddr2, &data2);'
   '  c_sub(&data1, &data2, &res);'
   '  createScalarDouble(pvApiCtx, nbInputArgument(pvApiCtx) + 1, res);'
   '  AssignOutputVariable(pvApiCtx, 1) = nbInputArgument(pvApiCtx) + 1;'
   '  return 0;'
   '}'];
mputl(j,TMP_DIR+filesep()+'sci_csub.c');


cur_dir = pwd();
chdir(TMP_DIR);

//creating the shared library (a gateway, a Makefile and a loader are 
//generated. 

files=['c_sub.c','sci_csub.c','c_sum.c','sci_csum.c'];
ilib_build('foo',['c_sum','sci_csum';'c_sub','sci_csub'],files,[]);


// load the shared library 
exec loader.sce;

if c_sum(3,5) <> 8 then pause,end
if c_sub(3,5) <> -2 then pause,end

chdir(cur_dir);

// ulink() all libraries
ulink();


//remove TMP_DIR
rmdir(TMP_DIR,'s');
// ====================================================================
